<template>
  <div class="responseInfo">
    <div class="response _success">
      <div class="paragraph">
        Мы выслали информацию о запросе на ваш e-mail
        <span class="link">{{ response.customerEmail }}</span>
      </div>
      <div class="paragraph">
        Отслеживать статус запроса вы можете в своем
        <flink
          class="link"
          href="/cabinet/outbox">Личном кабинете</flink>
      </div>

      <!--Информация об авто-->
      <div class="response-car">
        <div class="response-title">
          Ваш автомобиль
        </div>

        <div class="table tableResponseAuto">
          <section class="thead">
            <div class="tr">
              <div
                v-for="(item, index1) in tableAutoHeadings"
                :key="`table-th-${index1}`"
                :class="`th _${item.name}`">
                {{ item.title }}
              </div>
            </div>
          </section>
          <section class="tbody">
            <div class="tr">
              <div :class="`td _${tableAutoHeadings[0].name}`">
                <span class="td-title">{{ tableAutoHeadings[0].title }}:</span>
                <span class="td-value _gray-mobile">{{ response.carManufacturer }}</span>
              </div>
              <div :class="`td _${tableAutoHeadings[1].name}`">
                <span class="td-title">{{ tableAutoHeadings[1].title }}:</span>
                <span class="td-value _gray-mobile">{{ response.carModel }}</span>
              </div>
              <div :class="`td _${tableAutoHeadings[2].name}`">
                <span class="td-title">{{ tableAutoHeadings[2].title }}:</span>
                <span class="td-value _gray-mobile">{{ response.carReleaseYear }}</span>
              </div>
              <div :class="`td _${tableAutoHeadings[3].name}`">
                <span class="td-title">{{ tableAutoHeadings[3].title }}:</span>
                <span class="td-value _gray-mobile">{{ vin || 'не указано' }}</span>
              </div>
              <div :class="`td _${tableAutoHeadings[4].name}`">
                <span class="td-title">{{ tableAutoHeadings[4].title }}:</span>
                <span class="td-value _gray-mobile">{{ engine || 'не указано' }}</span>
              </div>
              <div :class="`td _${tableAutoHeadings[5].name}`">
                <span class="td-title">{{ tableAutoHeadings[5].title }}:</span>
                <span class="td-value _gray-mobile">{{ body || 'не указано' }}</span>
              </div>
            </div>
          </section>
        </div>
      </div>

      <!--Информация о запчастях-->
      <div class="response-parts">
        <div class="response-title">
          Ваши запчасти
        </div>

        <div class="table tableResponseParts">
          <section class="thead">
            <div class="tr">
              <div
                v-for="(item, index1) in tablePartsHeadings"
                :key="`table-th-${index1}`"
                :class="`th _${item.name}`">
                {{ item.title }}
              </div>
            </div>
          </section>
          <section class="tbody">
            <div
              v-for="(item, index) in response.partList"
              :key="index"
              class="tr">
              <div :class="`td _${tablePartsHeadings[0].name}`">
                <span class="td-title">Запчасть {{ index + 1 }}: </span>
                <span class="td-value">{{ index + 1 }}</span>
                <span class="td-value-mobile">{{ item.partName }}</span>
              </div>
              <div :class="`td _${tablePartsHeadings[1].name}`">
                <span class="td-title">{{ tablePartsHeadings[1].title }}:</span>
                <span class="td-value">{{ item.partName }}</span>
              </div>
              <div :class="`td _${tablePartsHeadings[2].name}`">
                <span class="td-title">{{ tablePartsHeadings[2].title }}:</span>
                <span class="td-value">{{ item.partCondition.name }}</span>
              </div>
              <div :class="`td _${tablePartsHeadings[3].name}`">
                <span class="td-title">{{ tablePartsHeadings[3].title }}:</span>
                <span class="td-value">{{ item.quantity }}</span>
              </div>
              <div :class="`td _${tablePartsHeadings[4].name}`">
                <span class="td-title">{{ tablePartsHeadings[4].title }}:</span>
                <span class="td-value _gray-mobile">{{ item.partVendorCode || 'не указано' }}</span>
              </div>
            </div>
          </section>
        </div>
      </div>
    </div>

    <div class="responseInfo-action">
      <button
        @click="returnToRequest"
        class="button">
        Отправить еще один запрос
      </button>
    </div>
  </div>
</template>

<script>
export default {
  name: 'AppResponseInfo',
  components: {},
  props: {
    response: {
      type: Object,
      default() { return {}; },
    },
    vin: {
      type: String,
      default: '',
    },
    body: {
      type: String,
      default: '',
    },
    engine: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      tableAutoHeadings: [
        {
          name: 'mark',
          title: 'Марка',
        },
        {
          name: 'model',
          title: 'Модель',
        },
        {
          name: 'year',
          title: 'Год выпуска',
        },
        {
          name: 'engine',
          title: 'Двигатель',
        },
        {
          name: 'body',
          title: 'Кузов',
        },
        {
          name: 'vin',
          title: 'VIN/FRAME номер',
        },
      ],
      tablePartsHeadings: [
        {
          name: 'number',
          title: '№',
        },
        {
          name: 'name',
          title: 'Название',
        },
        {
          name: 'type',
          title: 'Тип запчастей',
        },
        {
          name: 'amount',
          title: 'Количество, шт',
        },
        {
          name: 'comment',
          title: 'Комментарий',
        },
      ],
    };
  },
  methods: {
    returnToRequest() {
      // @todo сделать нормальную перезагрузку формы
      // this.$emit('reload')
      window.location.reload();
    },
  },
};
</script>

<style lang="postcss">
  /* Стили для всех таблицы */
  @import "~/assets/css/components/app-table-basic.css";

  .responseInfo {
    margin-top: -1.5rem;

    &-action {
      padding-top: 2rem;
    }

    .response {
      &-title {
        display: block;
        padding: 2rem 0 1rem;
        font-family: var(--font-heading);
        font-size: 1.125rem;
        font-weight: var(--font-weight-medium);
      }

      .paragraph {
        padding-top: 0.375rem;
        font-size: 0.75rem;
      }
    }

    .table.tableResponseAuto {
      .th {
        align-items: flex-start;
      }
      .th, .td {
        &._mark {
          grid-area: mark;
        }

        &._model {
          grid-area: model;
        }

        &._year {
          grid-area: year;
        }

        &._engine {
          grid-area: engine;
        }

        &._body {
          grid-area: body;
        }

        &._vin {
          grid-area: vin;
        }
      }

      @media screen and (min-width: 981px) {
        .tr {
          grid-template-columns: 1fr 1fr 1fr 1.5fr 1fr 1.5fr;
          grid-template-areas: "mark model year engine body vin";
        }

        .td-title {
          display: none;
        }
      }
    }

    .table.tableResponseParts {
      .th {
        align-items: flex-start;
      }
      .th, .td {
        &._number {
          grid-area: number;
        }

        &._name {
          grid-area: name;
        }

        &._type {
          grid-area: type;
        }

        &._amount {
          grid-area: amount;
          align-items: flex-end;
          text-align: right;
        }

        &._comment {
          grid-area: comment;
        }
      }

      @media screen and (min-width: 981px) {
        .tr {
          grid-template-columns: 0.3fr 1fr 1fr 0.75fr 1.75fr;
          grid-template-areas: "number name type amount comment";

          .td-title,
          .td-value-mobile {
            display: none;
          }
        }
      }
    }


    @media screen and (min-width: 981px) {

    }

    @media screen and (max-width: 980px) {
      margin-top: 0;
      padding: 0 1.25rem 4rem;

      .button {
        width: 100%;
        font-size: 1rem;
      }

      .response {
        &-title {
          padding: 1rem 0;
        }
        &-car {
          padding: 0;
        }

        &-parts {
          padding: 0;
        }

        .paragraph {
          padding-top: 0;
          padding-bottom: 0.5rem;
          font-size: 0.875rem;
        }
      }

      .table.tableResponseParts,
      .table.tableResponseAuto {
        .tbody {
          padding: 0;
          box-shadow: none;
          background: none;

          > .tr {
            display: block;
            margin: 0;
            padding: 0 0 1.5rem;
            border: none;
            box-shadow: none;

            ._gray-mobile {
              color: var(--color-main-lightest);
            }
          }
        }

        .td {
          display: flex;
          padding-bottom: 0.5rem;
          font-size: 0.875rem;
          line-height: 1.2;
          &._amount {
            text-align: left;
          }
        }

        .td-title {
          padding-right: 0.5rem;
          width: 45%;
          font-weight: var(--font-weight-medium);
        }
        .td-value {
          width: 55%;
        }
      }

      .table.tableResponseParts {
        .tbody .tr {
          .td:first-of-type {
            .td-value-mobile {
              width: 55%;
            }

            .td-value {
              display: none;
            }
          }

          .td:nth-of-type(2) {
            display: none;
          }
        }
      }
    }
  }
</style>
